#!/usr/local/bin/perl

$|=1;

$name  = "BOFH Excuse Calendar";

$flags = 0
    #+ 2			# Read-only
    #+ 4			# Dirty AppInfoArea
    + 8				# Backup this pdb (no conduit exists)
    #+ 16			# Ok to install newer pdb over older on Pilot
    #+ 32			# Force Pilot to reset after installing pdb
    ;

$version = 0x5555;

$pilot_time_delta = 2082844800;
$creation = $pilot_time_delta + time;
$s=sprintf("%u",$creation);
$creation=$s & 0xffffffff;
$last_modified = $s & 0xffffffff;

$type = "DATA";

$creator = "BEFH";

$offset=0;
$num_records=0;
$data="";

while(<>) {
    chop;
    $ofs[$num_records]=$offset;
    $data[$num_records++]=$_;
    $offset+=(length $_) + 1;
}

print pack("a32nnNNNNNNa4a4NNn",
	   $name,		# Database name
	   $flags,		# flags
	   $version,		# Version number
	   $creation,		# Creation date
	   $last_modified,	# Last modification
	   0,			# Last backup 
	   0,			# Modification number (0 is safe)
	   0,			# AppInfoArea (0 if none)
	   0,			# SortInfoArea (0 if none)
	   $type,		# Database type
	   $creator,		# Creator ID
	   0,			# Record seed (0 is safe)
	   0,			# 0 is safe
	   $num_records);	# Number of records

foreach $i (0..$num_records-1) {
    print pack("NCCCC",
	       78+$num_records*8+$ofs[$i],
	       0,0,0);
}

foreach $i (0..$num_records-1) {
    print pack("a*x",$data[$i]);
}

print $data;
